
/*
 * Camel EndpointConfiguration generated by camel-api-component-maven-plugin
 */
package org.apache.camel.component.braintree;

import org.apache.camel.spi.ApiMethod;
import org.apache.camel.spi.ApiParam;
import org.apache.camel.spi.ApiParams;
import org.apache.camel.spi.Configurer;
import org.apache.camel.spi.UriParam;
import org.apache.camel.spi.UriParams;

/**
 * Camel endpoint configuration for {@link com.braintreegateway.AddressGateway}.
 */
@ApiParams(apiName = "address", 
           description = "Provides methods to create, delete, find, and update Address objects",
           apiMethods = {@ApiMethod(methodName = "create", description="Creates an Address for a Customer", signatures={"com.braintreegateway.Result<com.braintreegateway.Address> create(String customerId, com.braintreegateway.AddressRequest request)"}), @ApiMethod(methodName = "delete", description="Deletes a Customer's Address", signatures={"com.braintreegateway.Result<com.braintreegateway.Address> delete(String customerId, String id)"}), @ApiMethod(methodName = "find", description="Finds a Customer's Address", signatures={"com.braintreegateway.Address find(String customerId, String id)"}), @ApiMethod(methodName = "update", description="Updates a Customer's Address", signatures={"com.braintreegateway.Result<com.braintreegateway.Address> update(String customerId, String id, com.braintreegateway.AddressRequest request)"})}, aliases = {})
@UriParams
@Configurer(extended = true)
public final class AddressGatewayEndpointConfiguration extends BraintreeConfiguration {
    @UriParam
    @ApiParam(optional = false, apiMethods = {@ApiMethod(methodName = "create", description="The id of the Customer"), @ApiMethod(methodName = "delete", description="The id of the Customer"), @ApiMethod(methodName = "find", description="The id of the Customer"), @ApiMethod(methodName = "update", description="The id of the Customer")})
    private String customerId;
    @UriParam
    @ApiParam(optional = false, apiMethods = {@ApiMethod(methodName = "delete", description="The id of the Address to delete"), @ApiMethod(methodName = "find", description="The id of the Address"), @ApiMethod(methodName = "update", description="The id of the Address")})
    private String id;
    @UriParam
    @ApiParam(optional = false, apiMethods = {@ApiMethod(methodName = "create", description="The request object"), @ApiMethod(methodName = "update", description="The request object containing the AddressRequest parameters")})
    private com.braintreegateway.AddressRequest request;

    public String getCustomerId() {
        return customerId;
    }

    public void setCustomerId(String customerId) {
        this.customerId = customerId;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public com.braintreegateway.AddressRequest getRequest() {
        return request;
    }

    public void setRequest(com.braintreegateway.AddressRequest request) {
        this.request = request;
    }
}
